diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/olsr/bindings/modulegen__gcc_LP64.py ns-3.32/src/olsr/bindings/modulegen__gcc_LP64.py
--- ns-3.31/src/olsr/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/olsr/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
@@ -7020,7 +7120,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('ns3::Address const &', 'arg1')], 
-                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7042,7 +7142,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0')], 
-                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7064,7 +7164,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('unsigned int', 'arg1')], 
-                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7086,7 +7186,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('unsigned int', 'arg0')], 
-                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3Ipv4ListRouting_methods(root_module, cls):
@@ -7942,6 +8042,8 @@
     return
 
 def register_Ns3OlsrRoutingProtocol_methods(root_module, cls):
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::RoutingProtocol::OLSR_PORT_NUMBER [variable]
+    cls.add_static_attribute('OLSR_PORT_NUMBER', 'uint16_t const', is_const=True)
     ## olsr-routing-protocol.h (module 'olsr'): static ns3::TypeId ns3::olsr::RoutingProtocol::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -7962,6 +8064,36 @@
                    'std::vector< ns3::olsr::RoutingTableEntry >', 
                    [], 
                    is_const=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::MprSet ns3::olsr::RoutingProtocol::GetMprSet() const [member function]
+    cls.add_method('GetMprSet', 
+                   'ns3::olsr::MprSet', 
+                   [], 
+                   is_const=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::MprSelectorSet const & ns3::olsr::RoutingProtocol::GetMprSelectors() const [member function]
+    cls.add_method('GetMprSelectors', 
+                   'ns3::olsr::MprSelectorSet const &', 
+                   [], 
+                   is_const=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::NeighborSet const & ns3::olsr::RoutingProtocol::GetNeighbors() const [member function]
+    cls.add_method('GetNeighbors', 
+                   'ns3::olsr::NeighborSet const &', 
+                   [], 
+                   is_const=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::TwoHopNeighborSet const & ns3::olsr::RoutingProtocol::GetTwoHopNeighbors() const [member function]
+    cls.add_method('GetTwoHopNeighbors', 
+                   'ns3::olsr::TwoHopNeighborSet const &', 
+                   [], 
+                   is_const=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::TopologySet const & ns3::olsr::RoutingProtocol::GetTopologySet() const [member function]
+    cls.add_method('GetTopologySet', 
+                   'ns3::olsr::TopologySet const &', 
+                   [], 
+                   is_const=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::OlsrState const & ns3::olsr::RoutingProtocol::GetOlsrState() const [member function]
+    cls.add_method('GetOlsrState', 
+                   'ns3::olsr::OlsrState const &', 
+                   [], 
+                   is_const=True)
     ## olsr-routing-protocol.h (module 'olsr'): int64_t ns3::olsr::RoutingProtocol::AssignStreams(int64_t stream) [member function]
     cls.add_method('AssignStreams', 
                    'int64_t', 
@@ -7992,23 +8124,48 @@
                    'ns3::Ptr< ns3::Ipv4StaticRouting const >', 
                    [], 
                    is_const=True)
-    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::RoutingProtocol::RoutingProtocol(ns3::olsr::RoutingProtocol const & arg0) [constructor]
-    cls.add_constructor([param('ns3::olsr::RoutingProtocol const &', 'arg0')])
-    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::DoInitialize() [member function]
-    cls.add_method('DoInitialize', 
-                   'void', 
-                   [], 
-                   visibility='protected', is_virtual=True)
     ## olsr-routing-protocol.h (module 'olsr'): ns3::Ptr<ns3::Ipv4Route> ns3::olsr::RoutingProtocol::RouteOutput(ns3::Ptr<ns3::Packet> p, ns3::Ipv4Header const & header, ns3::Ptr<ns3::NetDevice> oif, ns3::Socket::SocketErrno & sockerr) [member function]
     cls.add_method('RouteOutput', 
                    'ns3::Ptr< ns3::Ipv4Route >', 
                    [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Ipv4Header const &', 'header'), param('ns3::Ptr< ns3::NetDevice >', 'oif'), param('ns3::Socket::SocketErrno &', 'sockerr')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True)
     ## olsr-routing-protocol.h (module 'olsr'): bool ns3::olsr::RoutingProtocol::RouteInput(ns3::Ptr<const ns3::Packet> p, ns3::Ipv4Header const & header, ns3::Ptr<const ns3::NetDevice> idev, ns3::Ipv4RoutingProtocol::UnicastForwardCallback ucb, ns3::Ipv4RoutingProtocol::MulticastForwardCallback mcb, ns3::Ipv4RoutingProtocol::LocalDeliverCallback lcb, ns3::Ipv4RoutingProtocol::ErrorCallback ecb) [member function]
     cls.add_method('RouteInput', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet const >', 'p'), param('ns3::Ipv4Header const &', 'header'), param('ns3::Ptr< ns3::NetDevice const >', 'idev'), param('ns3::Callback< void, ns3::Ptr< ns3::Ipv4Route >, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'ucb'), param('ns3::Callback< void, ns3::Ptr< ns3::Ipv4MulticastRoute >, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'mcb'), param('ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'lcb'), param('ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::Ipv4Header const &, ns3::Socket::SocketErrno, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'ecb')], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True)
+    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::SetIpv4(ns3::Ptr<ns3::Ipv4> ipv4) [member function]
+    cls.add_method('SetIpv4', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::Ipv4 >', 'ipv4')], 
+                   is_virtual=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::Ptr<ns3::Ipv4> ns3::olsr::RoutingProtocol::GetIpv4() const [member function]
+    cls.add_method('GetIpv4', 
+                   'ns3::Ptr< ns3::Ipv4 >', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::PrintRoutingTable(ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) const [member function]
+    cls.add_method('PrintRoutingTable', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')], 
+                   is_const=True, is_virtual=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::Ipv4Address ns3::olsr::RoutingProtocol::GetMainAddress(ns3::Ipv4Address iface_addr) const [member function]
+    cls.add_method('GetMainAddress', 
+                   'ns3::Ipv4Address', 
+                   [param('ns3::Ipv4Address', 'iface_addr')], 
+                   is_const=True)
+    ## olsr-routing-protocol.h (module 'olsr'): ns3::olsr::RoutingProtocol::RoutingProtocol(ns3::olsr::RoutingProtocol const & arg0) [constructor]
+    cls.add_constructor([param('ns3::olsr::RoutingProtocol const &', 'arg0')])
+    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::DoInitialize() [member function]
+    cls.add_method('DoInitialize', 
+                   'void', 
+                   [], 
+                   visibility='protected', is_virtual=True)
+    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::DoDispose() [member function]
+    cls.add_method('DoDispose', 
+                   'void', 
+                   [], 
+                   visibility='protected', is_virtual=True)
     ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::NotifyInterfaceUp(uint32_t interface) [member function]
     cls.add_method('NotifyInterfaceUp', 
                    'void', 
@@ -8029,21 +8186,6 @@
                    'void', 
                    [param('uint32_t', 'interface'), param('ns3::Ipv4InterfaceAddress', 'address')], 
                    visibility='private', is_virtual=True)
-    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::SetIpv4(ns3::Ptr<ns3::Ipv4> ipv4) [member function]
-    cls.add_method('SetIpv4', 
-                   'void', 
-                   [param('ns3::Ptr< ns3::Ipv4 >', 'ipv4')], 
-                   visibility='private', is_virtual=True)
-    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::PrintRoutingTable(ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) const [member function]
-    cls.add_method('PrintRoutingTable', 
-                   'void', 
-                   [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')], 
-                   is_const=True, is_virtual=True, visibility='private')
-    ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::DoDispose() [member function]
-    cls.add_method('DoDispose', 
-                   'void', 
-                   [], 
-                   visibility='private', is_virtual=True)
     return
 
 def register_Ns3OlsrRoutingTableEntry_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/olsr/examples/olsr-hna.cc ns-3.32/src/olsr/examples/olsr-hna.cc
--- ns-3.31/src/olsr/examples/olsr-hna.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/olsr/examples/olsr-hna.cc	2020-10-06 15:35:43.000000000 -0700
@@ -135,7 +135,7 @@
     {
       wifi.EnableLogComponents ();  // Turn on all Wifi logging
     }
-  wifi.SetStandard (WIFI_PHY_STANDARD_80211b);
+  wifi.SetStandard (WIFI_STANDARD_80211b);
 
   YansWifiPhyHelper wifiPhy =  YansWifiPhyHelper::Default ();
   // This is one parameter that matters when using FixedRssLossModel
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/olsr/model/olsr-routing-protocol.cc ns-3.32/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.31/src/olsr/model/olsr-routing-protocol.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/olsr/model/olsr-routing-protocol.cc	2020-10-06 15:35:43.000000000 -0700
@@ -128,7 +128,6 @@
 #define JITTER (Seconds (m_uniformRandomVariable->GetValue (0, OLSR_MAXJITTER)))
 
 
-#define OLSR_PORT_NUMBER 698
 /// Maximum number of messages per packet.
 #define OLSR_MAX_MSGS           64
 
@@ -149,6 +148,9 @@
 
 NS_OBJECT_ENSURE_REGISTERED (RoutingProtocol);
 
+/* see https://www.iana.org/assignments/service-names-port-numbers */
+const uint16_t RoutingProtocol::OLSR_PORT_NUMBER = 698;
+
 TypeId
 RoutingProtocol::GetTypeId (void)
 {
@@ -194,7 +196,7 @@
 }
 
 
-RoutingProtocol::RoutingProtocol ()
+RoutingProtocol::RoutingProtocol (void)
   : m_routingTableAssociation (0),
   m_ipv4 (0),
   m_helloTimer (Timer::CANCEL_ON_DESTROY),
@@ -208,7 +210,7 @@
   m_hnaRoutingTable = Create<Ipv4StaticRouting> ();
 }
 
-RoutingProtocol::~RoutingProtocol ()
+RoutingProtocol::~RoutingProtocol (void)
 {
 }
 
@@ -235,7 +237,13 @@
   m_hnaRoutingTable->SetIpv4 (ipv4);
 }
 
-void RoutingProtocol::DoDispose ()
+Ptr<Ipv4>
+RoutingProtocol::GetIpv4 (void) const
+{
+  return m_ipv4;
+}
+
+void RoutingProtocol::DoDispose (void)
 {
   m_ipv4 = 0;
   m_hnaRoutingTable = 0;
@@ -368,6 +376,7 @@
       Ptr<Socket> socket = Socket::CreateSocket (GetObject<Node> (),
                                                  UdpSocketFactory::GetTypeId ());
       socket->SetAllowBroadcast (true);
+      socket->SetIpTtl (1);
       InetSocketAddress inetAddr (m_ipv4->GetAddress (i, 0).GetLocal (), OLSR_PORT_NUMBER);
       socket->SetRecvCallback (MakeCallback (&RoutingProtocol::RecvOlsr,  this));
       socket->BindToNetDevice (m_ipv4->GetNetDevice (i));
@@ -512,28 +521,28 @@
           switch (messageHeader.GetMessageType ())
             {
             case olsr::MessageHeader::HELLO_MESSAGE:
-              NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                            << "s OLSR node " << m_mainAddress
+              NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                            << " OLSR node " << m_mainAddress
                             << " received HELLO message of size " << messageHeader.GetSerializedSize ());
               ProcessHello (messageHeader, receiverIfaceAddr, senderIfaceAddr);
               break;
 
             case olsr::MessageHeader::TC_MESSAGE:
-              NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                            << "s OLSR node " << m_mainAddress
+              NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                            << " OLSR node " << m_mainAddress
                             << " received TC message of size " << messageHeader.GetSerializedSize ());
               ProcessTc (messageHeader, senderIfaceAddr);
               break;
 
             case olsr::MessageHeader::MID_MESSAGE:
-              NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                            << "s OLSR node " << m_mainAddress
+              NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                            << " OLSR node " << m_mainAddress
                             <<  " received MID message of size " << messageHeader.GetSerializedSize ());
               ProcessMid (messageHeader, senderIfaceAddr);
               break;
             case olsr::MessageHeader::HNA_MESSAGE:
-              NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                            << "s OLSR node " << m_mainAddress
+              NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                            << " OLSR node " << m_mainAddress
                             <<  " received HNA message of size " << messageHeader.GetSerializedSize ());
               ProcessHna (messageHeader, senderIfaceAddr);
               break;
@@ -641,7 +650,7 @@
 }  // unnamed namespace
 
 void
-RoutingProtocol::MprComputation ()
+RoutingProtocol::MprComputation  (void)
 {
   NS_LOG_FUNCTION (this);
 
@@ -952,10 +961,10 @@
 }
 
 void
-RoutingProtocol::RoutingTableComputation ()
+RoutingProtocol::RoutingTableComputation  (void)
 {
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " s: Node " << m_mainAddress
-                                                << ": RoutingTableComputation begin...");
+  NS_LOG_DEBUG (Simulator::Now ().As (Time::S) << " : Node " << m_mainAddress
+                                               << ": RoutingTableComputation begin...");
 
   // 1. All the entries from the routing table are removed.
   Clear ();
@@ -1282,8 +1291,8 @@
 #ifdef NS3_LOG_ENABLE
   {
     const LinkSet &links = m_state.GetLinks ();
-    NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                  << "s ** BEGIN dump Link Set for OLSR Node " << m_mainAddress);
+    NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                  << " ** BEGIN dump Link Set for OLSR Node " << m_mainAddress);
     for (LinkSet::const_iterator link = links.begin (); link != links.end (); link++)
       {
         NS_LOG_DEBUG (*link);
@@ -1291,8 +1300,8 @@
     NS_LOG_DEBUG ("** END dump Link Set for OLSR Node " << m_mainAddress);
 
     const NeighborSet &neighbors = m_state.GetNeighbors ();
-    NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                  << "s ** BEGIN dump Neighbor Set for OLSR Node " << m_mainAddress);
+    NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                  << " ** BEGIN dump Neighbor Set for OLSR Node " << m_mainAddress);
     for (NeighborSet::const_iterator neighbor = neighbors.begin (); neighbor != neighbors.end (); neighbor++)
       {
         NS_LOG_DEBUG (*neighbor);
@@ -1307,8 +1316,8 @@
 #ifdef NS3_LOG_ENABLE
   {
     const TwoHopNeighborSet &twoHopNeighbors = m_state.GetTwoHopNeighbors ();
-    NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                  << "s ** BEGIN dump TwoHopNeighbor Set for OLSR Node " << m_mainAddress);
+    NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                  << " ** BEGIN dump TwoHopNeighbor Set for OLSR Node " << m_mainAddress);
     for (TwoHopNeighborSet::const_iterator tuple = twoHopNeighbors.begin ();
          tuple != twoHopNeighbors.end (); tuple++)
       {
@@ -1400,8 +1409,8 @@
 #ifdef NS3_LOG_ENABLE
   {
     const TopologySet &topology = m_state.GetTopologySet ();
-    NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                  << "s ** BEGIN dump TopologySet for OLSR Node " << m_mainAddress);
+    NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                  << " ** BEGIN dump TopologySet for OLSR Node " << m_mainAddress);
     for (TopologySet::const_iterator tuple = topology.begin ();
          tuple != topology.end (); tuple++)
       {
@@ -1646,7 +1655,7 @@
 }
 
 void
-RoutingProtocol::SendQueuedMessages ()
+RoutingProtocol::SendQueuedMessages  (void)
 {
   Ptr<Packet> packet = Create<Packet> ();
   int numMessages = 0;
@@ -1682,7 +1691,7 @@
 }
 
 void
-RoutingProtocol::SendHello ()
+RoutingProtocol::SendHello  (void)
 {
   NS_LOG_FUNCTION (this);
 
@@ -1790,7 +1799,7 @@
 }
 
 void
-RoutingProtocol::SendTc ()
+RoutingProtocol::SendTc  (void)
 {
   NS_LOG_FUNCTION (this);
 
@@ -1814,7 +1823,7 @@
 }
 
 void
-RoutingProtocol::SendMid ()
+RoutingProtocol::SendMid  (void)
 {
   olsr::MessageHeader msg;
   olsr::MessageHeader::Mid &mid = msg.GetMid ();
@@ -1859,7 +1868,7 @@
 }
 
 void
-RoutingProtocol::SendHna ()
+RoutingProtocol::SendHna  (void)
 {
 
   olsr::MessageHeader msg;
@@ -1982,7 +1991,7 @@
   Time now = Simulator::Now ();
   bool updated = false;
   bool created = false;
-  NS_LOG_DEBUG ("@" << now.GetSeconds () << ": Olsr node " << m_mainAddress
+  NS_LOG_DEBUG ("@" << now.As (Time::S) << ": Olsr node " << m_mainAddress
                     << ": LinkSensing(receiverIface=" << receiverIface
                     << ", senderIface=" << senderIface << ") BEGIN");
 
@@ -2031,8 +2040,9 @@
         case OLSR_LOST_LINK:
           linkTypeName = "LOST_LINK";
           break;
-        default: linkTypeName = "(invalid value!)";
-          
+        default:
+          linkTypeName = "(invalid value!)";
+
         }
 
       const char *neighborTypeName;
@@ -2117,7 +2127,7 @@
                                            &RoutingProtocol::LinkTupleTimerExpire, this,
                                            link_tuple->neighborIfaceAddr));
     }
-  NS_LOG_DEBUG ("@" << now.GetSeconds () << ": Olsr node " << m_mainAddress
+  NS_LOG_DEBUG ("@" << now.As (Time::S) << ": Olsr node " << m_mainAddress
                     << ": LinkSensing END");
 }
 
@@ -2338,8 +2348,8 @@
 void
 RoutingProtocol::NeighborLoss (const LinkTuple &tuple)
 {
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                << "s: OLSR Node " << m_mainAddress
+  NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                << ": OLSR Node " << m_mainAddress
                 << " LinkTuple " << tuple.neighborIfaceAddr << " -> neighbor loss.");
   LinkTupleUpdated (tuple, OLSR_WILL_DEFAULT);
   m_state.EraseTwoHopNeighborTuples (GetMainAddress (tuple.neighborIfaceAddr));
@@ -2394,8 +2404,8 @@
 void
 RoutingProtocol::RemoveLinkTuple (const LinkTuple &tuple)
 {
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                << "s: OLSR Node " << m_mainAddress
+  NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                << ": OLSR Node " << m_mainAddress
                 << " LinkTuple " << tuple << " REMOVED.");
 
   m_state.EraseNeighborTuple (GetMainAddress (tuple.neighborIfaceAddr));
@@ -2407,8 +2417,8 @@
 {
   // Each time a link tuple changes, the associated neighbor tuple must be recomputed
 
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds ()
-                << "s: OLSR Node " << m_mainAddress
+  NS_LOG_DEBUG (Simulator::Now ().As (Time::S)
+                << ": OLSR Node " << m_mainAddress
                 << " LinkTuple " << tuple << " UPDATED.");
 
   NeighborTuple *nb_tuple =
@@ -2509,7 +2519,7 @@
 }
 
 void
-RoutingProtocol::IncrementAnsn ()
+RoutingProtocol::IncrementAnsn  (void)
 {
   m_ansn = (m_ansn + 1) % (OLSR_MAX_SEQ_NUM + 1);
 }
@@ -2613,14 +2623,14 @@
 }
 
 void
-RoutingProtocol::HelloTimerExpire ()
+RoutingProtocol::HelloTimerExpire  (void)
 {
   SendHello ();
   m_helloTimer.Schedule (m_helloInterval);
 }
 
 void
-RoutingProtocol::TcTimerExpire ()
+RoutingProtocol::TcTimerExpire  (void)
 {
   if (m_state.GetMprSelectors ().size () > 0)
     {
@@ -2634,14 +2644,14 @@
 }
 
 void
-RoutingProtocol::MidTimerExpire ()
+RoutingProtocol::MidTimerExpire  (void)
 {
   SendMid ();
   m_midTimer.Schedule (m_midInterval);
 }
 
 void
-RoutingProtocol::HnaTimerExpire ()
+RoutingProtocol::HnaTimerExpire  (void)
 {
   if (m_state.GetAssociations ().size () > 0)
     {
@@ -2815,7 +2825,7 @@
 }
 
 void
-RoutingProtocol::Clear ()
+RoutingProtocol::Clear  (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
   m_table.clear ();
@@ -2971,10 +2981,12 @@
           // multicast routing protocol can handle it.  It should be possible
           // to extend this to explicitly check whether it is a unicast
           // packet, and invoke the error callback if so
+          NS_LOG_LOGIC ("Null local delivery callback");
           return false;
         }
     }
 
+  NS_LOG_LOGIC ("Forward packet");
   // Forwarding
   Ptr<Ipv4Route> rtentry;
   RoutingTableEntry entry1, entry2;
@@ -3018,6 +3030,7 @@
     }
   else
     {
+      NS_LOG_LOGIC ("No dynamic route, check network routes");
       if (m_hnaRoutingTable->RouteInput (p, header, idev, ucb, mcb, lcb, ecb))
         {
           return true;
@@ -3110,7 +3123,7 @@
 
 
 std::vector<RoutingTableEntry>
-RoutingProtocol::GetRoutingTableEntries () const
+RoutingProtocol::GetRoutingTableEntries  (void) const
 {
   std::vector<RoutingTableEntry> retval;
   for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator iter = m_table.begin ();
@@ -3121,6 +3134,42 @@
   return retval;
 }
 
+MprSet
+RoutingProtocol::GetMprSet  (void) const
+{
+  return m_state.GetMprSet ();
+}
+
+const MprSelectorSet &
+RoutingProtocol::GetMprSelectors  (void) const
+{
+  return m_state.GetMprSelectors ();
+}
+
+const NeighborSet &
+RoutingProtocol::GetNeighbors  (void) const
+{
+  return m_state.GetNeighbors ();
+}
+
+const TwoHopNeighborSet &
+RoutingProtocol::GetTwoHopNeighbors  (void) const
+{
+  return m_state.GetTwoHopNeighbors ();
+}
+
+const TopologySet &
+RoutingProtocol::GetTopologySet  (void) const
+{
+  return m_state.GetTopologySet ();
+}
+
+const OlsrState &
+RoutingProtocol::GetOlsrState (void) const
+{
+  return m_state;
+}
+
 int64_t
 RoutingProtocol::AssignStreams (int64_t stream)
 {
@@ -3175,7 +3224,7 @@
 }
 
 Ptr<const Ipv4StaticRouting>
-RoutingProtocol::GetRoutingTableAssociation () const
+RoutingProtocol::GetRoutingTableAssociation  (void) const
 {
   return m_hnaRoutingTable;
 }
